Re: Greenstone Install problem

From Stefan Boddie
DateMon, 03 Feb 2003 20:54:38 +1300
Subject Re: Greenstone Install problem
In-Reply-To (1044212943-2708-30-camel-garfield)
Hi Don,

It seems we have some issues with Greenstone under some of the newer
linux distributions. I just installed the linux binary release of
gsdl-2.38 under Debian Sid (perl 5.8.0, gcc 3.2.2) and had the same
problem you described. I assume that you installed the linux binaries?

Problem number 1: The pre-compiled copy of the XML-Parser perl module
that we distribute with Greenstone doesn't work with perl 5.8.0. It
would seem that modules compiled for older perl's are not binary
compatible with 5.8. I'm not sure yet what we'll do with the next
Greenstone release but the best solution for now is to install and
compile the Greenstone source instead of the binary version. Do that in
the same way you installed the binaries (by running Install.sh and
following the instructions) but choose the [c]ompile option instead of
the default [b]inary option when given the choice. Before doing this see
problem number 2 below.

Problem number 2: As discussed between Gordon and John McP on this list
a week or two ago there's a problem compiling the Greenstone source with
gcc-3.2. According to the SuSE website SuSE linux 8.1 includes gcc-3.2
so you'll have this problem if you go ahead and try to compile from
source. To work around this problem you should do the following:

* Extract the gsdl-2.38-linux.tgz archive to create the gsdl-2.38-linux
directory (as I'm sure you've already done).

* Edit gsdl-2.38-linux/src/src/mgpp/lib/sysfuncs.h to comment out line
341 (the line reads -- #define textdomain(Domain) --).

* Go to gsdl-2.38-linux/Unix and run the ./Install.sh script as before
(but this time selecting the [c]ompile option).

If possible (and if they're still reading this :-) could John and/or
Gordon let me know what they think the best solution to this bug is? We
need to get a fix committed to CVS soon as I'm just in the process of
creating the gsdl-2.39 release.

Problem number 3: I've been aware for a while that there might be some
problems with Greenstone under perl 5.8 with the low level way we handle
non-ascii character sets. If you find that these characters are being
converted to junk by the Greenstone build process this is likely to be
the culprit. You might also notice lots of warning messages from perl
while importing a collection with perl 5.8 (though in many cases these
are harmless). I'm working on fixing this for the next release and will
probably be able to provide a patch for gsdl-2.38 soon if anyone wants it.

regards,
Stefan.

Don Dollberg wrote:
> I have installed Greenstone on a SuSE LINUX 8.1 system which is running
> PERL 5.8.0 and Apache 1.3.X. While it would appear that all went well I
> am having problems running the Collector or the equivalent command line
> import.pl.
>
> I have run source setup.bash and the environemnt variable GSDLHOME is
> set to the install tree at /usr/local/gsdl GSDL_OS is set to LINUX and
> the entire gsdl tree is full read, write and execute (chmod 777).
>
> When I run import.pl demo (demo collection provided with greenstone)
> with the collect.cfg provided, even as root, the following errors
> appear:
>
> -------------------------------------------
>
> garfield:/usr/local/gsdl/bin/script # ./import.pl demo
>
> Uncaught exception from user code:
> Can't load
> '/usr/local/gsdl/perllib/cpan/auto/XML/Parser/Expat/Expat.so' for module
> XML::Parser::Expat:
> /usr/local/gsdl/perllib/cpan/auto/XML/Parser/Expat/Expat.so: undefined
> symbol: PL_sv_undef at
> /usr/lib/perl5/5.8.0/i586-linux-thread-multi/DynaLoader.pm line 229.
> at /usr/local/gsdl/perllib/cpan/XML/Parser.pm line 15
> Compilation failed in require at
> /usr/local/gsdl/perllib/cpan/XML/Parser.pm line 15.
> BEGIN failed--compilation aborted at
> /usr/local/gsdl/perllib/cpan/XML/Parser.pm line 19.
> Compilation failed in require at
> /usr/local/gsdl/perllib/plugins/XMLPlug.pm line 36.
> BEGIN failed--compilation aborted at
> /usr/local/gsdl/perllib/plugins/XMLPlug.pm line 36.
> Compilation failed in require at
> /usr/local/gsdl/perllib/plugins/GAPlug.pm line 32.
> BEGIN failed--compilation aborted at
> /usr/local/gsdl/perllib/plugins/GAPlug.pm line 32.
> Compilation failed in require at /usr/local/gsdl/perllib/plugin.pm line
> 55.
> plugin::load_plugins('ARRAY(0x82fd594)',2,'STDERR','import::FAILLOG')
> called at ./import.pl line 247
> import::main() called at ./import.pl line 94
>
> ----------------------------------------------
>
> Am I missing a PERL module other than provided by Greenstone or is this
> a confi problem with the original install? Afte looking through the
> archives I noticed a problem in an earlier version of greenstone related
> to the module XML::parser but the answer did not seem to address this
> problem which susggests a PERL problem. BTW PERL and the standard
> libraries are in the usual directories as installed by SuSE,
> /usr/bin/perl and /usr/lib/perl etc.
>
> Thoughts? Ideas? on how to resolve the problem.
>
> Thank you
> Don Dollberg
> dond@spsp.net
>